var gLifeTime=2;//in seconds.
var abData=null;
var abURI=null;
var abMime='text/plain';
var ioService=Components.classes["@mozilla.org/network/io-service;1"]
               .getService(Components.interfaces.nsIIOService);
var mabFiles;
var strings;

function upload()
{
  strings = document.getElementById("strings");
  mabFiles=syncedAddressbooks();

  var synctype;
  try{ synctype = pref.getCharPref( "extensions.addressbookssync.synctype" ); }
    catch(e){ synctype = 'none'; }

//TODO: be sure, Adressbooks are synced with file!!

  if (synctype=='local') {
    var directory=pref.getCharPref( "extensions.addressbookssync.localpath" )
    if (directory) {
      var dir = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
      dir.initWithPath( directory );
      for (var i = 0; i < mabFiles.length; i++) {
        var mabFile=mabFiles[i];
        var mabName=getAddressBook(mabFile).directoryProperties.description;
        statustxt("\n"+mabName+'..');
        if (saveMabFile(mabName, mabFile, dir))
          statustxt(strings.getString('copied'));
        else
          statustxt(strings.getString('notcopied'));
      }
    }
    killMe();
  } else if (synctype=='remote') {
    abURI=getSyncURI();
    setTimeout(sendData, 0);
  } else {
    killMe();
  }

}

function sendData()
{
    var mabFile=mabFiles.pop();
    if (!mabFile) {
      killMe();
      return;
    }
    mabName=getAddressBook(mabFile).directoryProperties.description;

//    MabFileName = mabName.replace( /\s|\./g, "_" );
//TODO: UTF8
    var remoteFileName = mabName+".mab";

    var mabURI=abURI+remoteFileName;
    var URI=ioService.newURI(mabURI,this.charset,null);

    statustxt("\nupload "+mabName+"..");

    abData=readMabData(mabFile, true);
    if (!abData) return;

    if( ! gBookmarksSynchronizerUploadService.start(abData, URI, abMime, uploadCallback))
      uploadCallback("done",-1);

}

function uploadCallback(aStatus,aError)
{
  if (aStatus=='send') {
    statustxt('.');
    return;
  } else {
    var error=errorstr(aError);
    statustxt(error);
    if (error!=strings.getString('ok')) {
      gLifeTime=5;//in seconds.
      killMe();
      return;
    }
  }
  sendData(); //next addressbook
}

function statustxt(aStatus)
{
  document.getElementById("status").value += aStatus;
}

function cancelUpload()
{
  gBookmarksSynchronizerUploadService.cancel();
  killMe();
}

function killMe()
{
  if(gLifeTime>0)
  {
    gLifeTime--;
    setTimeout(killMe,1000);
  }
  else setTimeout(close,0);
}

